#!perl   -w

# WebMaven v1.01
# written by David Rhoades (with apologies to real programmers everywhere)
# "Give a man an audit and he will be secure for a day.  Teach a man to audit and he will be secure for the rest of his life." -David Rhoades
# Maven Security Consulting, Inc.
# www.mavensecurity.com
#  Enhanced by admin@mokshafaced.com(sgt) to be compatible on Apache
#    WebMaven - An interactive web application that emulates various security holes useful for 
#    safely & legally practicing security audit techniques, as well as benchmarking and vetting audit tools.
#    Copyright (C) 2002 David Rhoades (rhoades@mavensecurity.com)
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details (http://www.gnu.org/licenses/gpl.txt).
#    You should have received a copy of the GNU General Public License
#    along with this program (license.txt); if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#	 Or go online to http://www.gnu.org/licenses/gpl.txt
#	 The latest version of WebMaven can be found at http://sourceforge.net/projects/webmaven
# Instructions
# - install a web server (tested on Xitami with Windows 2000 - http://www.xitami.com/)
# - ensure Perl is installed and supported by web server (tested with Active State Perl - http://www.activestate.com/)
# - unzip WebMaven zip file 
# - place wm directory outside web server document root (we don't want web browsers pulling these files off directly) but within reach of cgi-bin (for Xitami on Win32 system, this would be C:\Xitami\wm)
#   The wm.cgi code will look for its data file within the wm directory, which it expects to be at the safe filesystem level as the cgi-bin directory (i.e. cgi-bin and wm directories have the same parent directory)
# - place wm.cgi within the cgi-bin directory (for Xitamin on Win32 system this would be C:\Xitami\cgi-bin\wm.cgi)
# - place the templates folder within the cgi-bin directory
# - (setup 1 - for broken graphics) place the webmaven_html folder within the web server document root (for Xitami on Win32 system this would be C:\Xitamin\webpages\webmaven_html)
# - (setup 2 - for graphics to work) place the content of the webmaven_html folder directly into the web server document root - this migt overwrite your current index.html (so rename the new one to something else if you want like webmaven.html but a static link (Return Home) will not work anymore  
# - (setup 3 - for the best setup) create a virtual web site and point the default web server document root to the webmaven_html folder (How to do this is left as an exercise for the reader.)  If you do not create
# - surf to your web site:
# setup 1 (assuming 127.0.0.1) http://127.0.0.1/webmaven_html/index.html
# setup 2 (assuming 127.0.0.1) http://127.0.0.1/index.html
# setup 3 (assuming virtual server is www.webmaven.usa) http://www.webmaven.usa
# SPOILER - Don't read past this point if you don't want to know the vulnerabilities emulated.
# This fake banking application demonstrates the following:
# - anti-caching techniques are not used on pages displaying sensitive data
# - predictable session ID in SessionID cookie; session cloning (aka session hijacking of current sessions)
# - ODBC / SQL error message when special characters placed in "transaction" parameter
# - collecting balances for other customers by exploiting a logic flaw
# - XSS via "transaction"parameter
# - hidden comment in home page pointing to old CGI source code
# - user name harvesting
# - password harvestingvia error message for locked accounts
# - command injection; OS commands embedded after semi-colon (;) in Account cookie (only PING or NETSTAT commands are supported because we don't want anybody hurting themselves :-)
# - GET method exposes user account number and PIN in URL during login

use CGI qw(:standard -debug);
use HTTP::Date; 
#print "Content-type: text/html\n\n";

$cgi_name = 'wm.cgi';
($date) = time2str;

# If past session IDs have not be defined then initial them now
&InitSessionIDs if !(-e "../wm/siddb.pag");

open($USER_FILE, "../wm/wm.dat") || die "cannot open file: $!";
$count = 0;
while (<$USER_FILE>) {
	chop;
	($userid, $pin, $name, $account1, $bal1, $account2, $bal2, $past, $pgp) = split(/:/,$_,9);
	$count = $count + 1;
	$pin_list{$userid} = $pin;
	$name_list{$userid} = $name;
	$account1_list{$userid} = $account1;
	$account2_list{$userid} = $account2;
	$bal_list{$account1} = $bal1;
	$bal_list{$account2} = $bal2;
	#$user_list{$count} = $userid; #not implemented yet //sgt
	$past_sessions{$userid} = $past;
        $pgp2user{$pgp} = $userid;
	$user2pgp{$userid} = $pgp;
}
close($USER_FILE);

dbmopen(%LOCKCOUNT, "../wm/lockdb", 0666) || die "Can't open database lockdb!";

dbmopen(%SID, "../wm/siddb", 0666) || die "Can't open database siddb!";

sub InitSessionIDs {
# This subroutine will create past session IDs simulating other users.
# These predictable session ID will allow the user to perform session cloning (aka session hijacking).
# Vulnerability - Session ID are weak (predictable).
	$timerange = 300; #	define range of past - default 300 seconds, can redefine lower for easier testing
	dbmclose(%SID);
	unlink ("../wm/siddb.dir", "../wm/siddb.pag");
	dbmopen(%SID, "../wm/siddb", 0666) || die "Can't open database siddb!";
	($datestring) = time;
	($datestring) = substr $datestring, 0, 10; # only 10 digits

	# For each users with a past session, create a session ID for them in the recent past
	foreach $user (keys %past_sessions) {
		if ($past_sessions{$user} eq 1) {
			# pick random number to represent a random number of seconds in the past
			$delta = int(rand $timerange) + 1;
			my $sessionid = $datestring - $delta;
			$SID{"$sessionid"} = $user;	
		} # end if
	} # end foreach

	$mycookie = cookie(-name=>'SessionID', -value=>$datestring, -path=>"/cgi-bin/$cgi_name"); 	# build new cookie
	# send new cookie and tell them not to cache the page

 print header(-cookie=>$mycookie, -expires=>'now');

} # end sub 

sub ValidateSID {
# This subroutine will validate that the session ID sent is a currently valid session ID
	if ($SID{$sid} eq '') {
		$mycookie = cookie(-name=>'SessionID', -value=>"", -path=>"/cgi-bin/$cgi_name"); 	# build new cookie
		# send new cookie and tell them not to cache the page
		print header(-cookie=>$mycookie, -expires=>'now');
		# session ID is not valid
      		print start_html(-title=>'Buggy Bank - Invalid Session Error');
		print @header;
 		print h2('Session Expired / Invalid'), 
 		p,
 		"Your session has expired or is invalid - please go back to the Login page.",
 		p,
 		hr;
		print a({-href=>"/cgi-bin/$cgi_name"},"Return to login page."),
		hr;
		print @footer;
		die; 
	} #end if
} # end sub


# check if session ID cookie was sent - if not then generate a new one based on time stamp
($sid) = cookie('SessionID');
if ($sid eq "") {
	# no cookie or blank value sent - therefore create a new one
	# generate value based on current time stamp
	($datestring) = time;
	# but only 10 digits; i.e. seconds.  Some systems support milliseconds, but that would make session hijacking too hard
	($datestring) = substr $datestring, 0, 10;
	$mycookie = cookie(-name=>'SessionID', -value=>$datestring, -path=>"/cgi-bin/$cgi_name"); 	# build new cookie
	# send new cookie and tell them not to cache the page
	$URL = http('HTTP_SERVER_URL') . http('HTTP_SCRIPT_NAME');

	print redirect(-location=>$URL, -cookie=>$mycookie, -expires=>'now');
	die;
}

($pgp) = cookie('Account');
if ($pgp =~ m/\;/) { 
	# Vulnerability - Command Injection via special character in Account cookie
	# This vulnerability was discovered by David Rhoades during an assessment for a large global bank several years ago.
	# The PGP version number should be an indicator as to when this was discovered.
	# A semi-colon followed by an OS-level command resulted in the web server running the command >:-O
	# Cookie contained the PGP encrypted account number, which allowed users to avoid typing in their account
	# number every time they went to the login page.  Apparently, the cookie data was not scrubbed of special
	# characters before being passed to PGP across a command line.  "Gump" happens.

 	print header(-expires=>'now');
	print "Content-type: text/html\n\n";###Options +Multiviews in httpd.conf on the Apache server//sgt
 	print "PGP v2.6 error",
	p;
	if (($address) = $pgp =~ m/netstat/) {
		system ("netstat -na");
	}	
	if (($address) = $pgp =~ m/ping (\d*\.\d*\.\d*\.\d*)/) {
		system ("ping $address");
	}
	die; # quit early to avoid printing processing other transactions
} 


# Read in HTML template for page header and footer
open (HEADER1, './templates/wm-header.txt') || die "Could not open header template\n";
@header = <HEADER1>;
close(HEADER1);
open (FOOTER1, './templates/wm-footer.txt') || die "Could not open footer template\n";
@footer = <FOOTER1>;
close(FOOTER1);

	 
if (!param()) {	
($pgp) = cookie('Account');

 print header(-expires=>'now');

	print start_html('Welcome to Buggy Bank - Login');
	print @header;
	print comment('The source code for the old sign-on CGI is at /backup/login.cgi.bak');
	print img {src=>'/money_burning_md_wht.gif'};
	#print "Content-type: text/html \n\n";
####Options +Multiviews in httpd.conf on Apache//sgt
 	print h1('Please sign in.');
	# vulnerability - uses GET method, thus exposing sensitive user input on URL (e.g. browser history file).
	print start_form(-method=>'GET'),
	"Account Number ",textfield(-name=>'userid', default=>$pgp2user{$pgp}),
   	 p,"PIN ",password_field('pin'),p,
    	hidden(-name=>'transaction',-value=>['login']),p,
    	submit,
    	end_form,
	p,
	a({-href=>"/cgi-bin/$cgi_name?transaction=reset"},"Reset all accounts to beginning state."),				
	hr;
	print @footer;

# reset account lockouts and session IDs
} elsif (param('transaction') eq "reset") {
	&InitSessionIDs;

 	print start_html('WebMaven accounts reset');
	print @header;
	foreach $account (keys %LOCKCOUNT) {
     	$LOCKCOUNT{"$account"} = 0;
}
	print h1('Accounts have been reset to their beginning state.');
	print a({-href=>"/cgi-bin/$cgi_name"},"Return to login page."),
	hr;
	print @footer;

} elsif (param('transaction') eq "login") {
	if ($pin_list{param('userid')} && ($pin_list{param('userid')} eq param('pin'))) {
		# non-blank userid & valid PIN - now check for locked account		
		if ($LOCKCOUNT{param('userid')} eq 3) {
		# valid userID and PIN but locked account
		# Vulnerability - Error wording is different for valid versus invalid PIN on locked account
		# Attacker could lock accounts then exhaustive brute force the PIN, then hope the account is reset 
		# without changing the PIN.  Seen for major bank in Europe (not found in their US and Asia versions).
		print "Content-type: text/html \n\n";####Options +Multiviews on Apache in httpd.conf //sgt	
      		print start_html('Buggy Bank - Account Locked');
      		print @header;
		print h2("Account is locked"),
		p,
		"Sorry, your account has been suspended.",
		p,
		"Please contact customer service for details",
		p, p,
		a({-href=>"/cgi-bin/$cgi_name"},"Return to Login page of Buggy Bank"),
		p, hr;
		} else {
		# correct login and not locked so record session ID
		$user = param('userid');
		$SID{"$sid"} = $user; # record session ID and user ID into db
		# and create PGP cookie			
		$mypgpcookie = cookie(-name=>'Account', -value=>$user2pgp{$user}, -path=>"/cgi-bin/$cgi_name", -expires=>"+30d");
		# send new cookie and tell them not to cache the page
		print header(-cookie=>$mypgpcookie, -expires=>'now');
      		print start_html("Buggy Bank - Login Success");
		print @header;
      		print h2("Welcome ", $name_list{$user}, " to your Account Home Page."),
		p,
		"From here you may: ",
		p,
		a({-href=>"/cgi-bin/$cgi_name?transaction=summary"},"View a summary of your accounts"),
		p,
		a({-href=>"/cgi-bin/$cgi_name?transaction=transfer"},"Transfer funds between accounts"),
		p,
		a({-href=>"/cgi-bin/$cgi_name?transaction=logout"},"Logout of Buggy Bank"),
		p,
		hr;
		}
	} elsif ($pin_list{param('userid')}) {
		print "Content-type: text/html \n\n";
      		print start_html('Buggy Bank - Login Failed');
     		print @header;
      		# login failed because PIN wrong - check to see if the account is locked
      if ($LOCKCOUNT{param('userid')} eq 3) {
	# valid userID, incorrect PIN but locked account
        print h2("Account is locked"),
	p,
	"Sorry, your account has been locked.",
	p,
	"Please contact customer service for details",
	p, p,
	a({-href=>"/cgi-bin/$cgi_name"},"Return to Login page of Buggy Bank"),
	hr;
	} else {
	# login failed due to bad PIN, but account was not locked yet
	# Vulnerability - this error message is different from others so that attacker can harvest valid account numbers
	$LOCKCOUNT{param('userid')} = $LOCKCOUNT{param('userid')} + 1; 
        print h2("Login Failed"),
	p,
	"You entered the incorrect PIN",
	p,
	"Please try again (and again, and again, and again)",
	p, 
	"If you lost your PIN please call customer service or feel free to brute force attack this CGI",
	p, p,
	a({-href=>"/cgi-bin/$cgi_name"},"Return to login page."),
	hr;
	}
	} else {
	# login failed because user ID does not exist in database
	print "Content-type: text/html \n\n";
    	print start_html('Buggy Bank - Login Failed');
    	print @header;
	print h2('Login failed'), 
	p,
	"You entered an invalid account number",
	p,
	"(so don't bother trying to guess the PIN - Perhaps trying another account number would be more fruitful.)",
	hr;
	print a({-href=>"/cgi-bin/$cgi_name"},"Return to login page."),
	hr;
	}
print @footer;
} elsif (param('transaction') eq "summary") {
	# show account summary
	&ValidateSID;
	print "Content-type: text/html \n\n";
    	print start_html(-title=>'Buggy Bank - Account Summary Page');
  	print @header;
    	print comment('This page generated with Cold Fusion version 0.9');
	print h2("Account Summary for ", $name_list{$SID{$sid}}),
	p,
	hr,
	h3("As of $date your account balances are:"),
	p,
	"Account # ", $account1_list{$SID{$sid}},
	p,
	"Balance is \$", $bal_list{$account1_list{$SID{$sid}}},
	p,
	"",
	p,
	"Account # ", $account2_list{$SID{$sid}},
	p,
	"Balance is \$", $bal_list{$account2_list{$SID{$sid}}},
	p,
	hr;
	print a({-href=>"/cgi-bin/$cgi_name?transaction=transfer"},"Transfer funds between accounts"),
	p,
	a({-href=>"/cgi-bin/$cgi_name?transaction=logout"},"Logout"),
	p, hr;
	print @footer;

} elsif (param('transaction') eq "logout") {
	# logout user
	$mycookie = cookie(-name=>'SessionID', -value=>"", -path=>"/cgi-bin/$cgi_name"); # remove session ID from cookie

 print header(-cookie=>$mycookie, -expires=>'now');
    $SID{"$sid"} = ''; # remove session ID from DB

  print start_html('Buggy Bank - Logout Page');

  print @header;
	print h2('Thank you for hacking at Buggy Bank...please come back if you need more money.'), p;
	print a({-href=>"/cgi-bin/$cgi_name"},"Return to login page."),
	hr;
	print @footer;

} elsif (param('transaction') eq "transfer") {

   ($sid) = cookie('SessionID');	
    print "Content-type: text/html \n\n";
    print start_html('Buggy Bank - Funds Transfer');
    print @header;
    print h2('Account Summary'), p;
    print "Account # ", $account1_list{$SID{$sid}}, " --- Balance is \$" , $bal_list{$account1_list{$SID{$sid}}};
    print p;
    print "Account # ", $account2_list{$SID{$sid}}, " --- Balance is \$", $bal_list{$account2_list{$SID{$sid}}};
    print p, hr;
    param('transaction','transfer2'); # must define prior to printing it

	print start_form,
    h2('Perform funds transfer between your accounts'),
    p,
    "From Account  ",
    popup_menu('from', [$account1_list{$SID{$sid}},$account2_list{$SID{$sid}}]),
    p,
    "To Account  ",
    popup_menu('to', [$account1_list{$SID{$sid}},$account2_list{$SID{$sid}}]),
    p,
    "Amount to transfer \$", textfield('amount'),
    p,
    hidden('transaction'),
    submit,
    end_form,
    hr,
    p, a({-href=>"/cgi-bin/$cgi_name?transaction=summary"},"Go to the Account Summary Page"),
    p, a({-href=>"/cgi-bin/$cgi_name?transaction=logout"},"Logout"),
    hr;
    print @footer;

} elsif (param('transaction') eq "transfer2") {
	($sid) = cookie('SessionID');
	$acct1 = $account1_list{$SID{$sid}};
	$acct2 = $account2_list{$SID{$sid}};
	
	print "Content-type: text/html \n\n";
  	print start_html('Buggy Bank - Funds Transfer Status');
  	print @header;
 	# flag if the accounts are the same
 	if (param('from') eq param('to')) {
 		print h2('It appears that you selected the same TO and FROM accounts...that\'s not right!');
		print a({-href=>"/cgi-bin/$cgi_name?transaction=transfer"},"Go Back to Transfer Page and try again"),
		p, a({-href=>"/cgi-bin/$cgi_name?transaction=summary"},"Go Back to Summary Page"),
		p, a({-href=>"/cgi-bin/$cgi_name?transaction=logout"},"Logout"),
		hr;
	# check for valid accounts
	}elsif (($bal_list{param('from')} == '') || ($bal_list{param('to')} == '')) {
 		# one or both of the accounts are not valid
		print "Content-type: text/html \n\n";
   		print h2('Invalid Account'), 
 		p,
 		"Your transfer could not be processed: Invalid account reference(s)",
 		p,
 		hr;
 		print a({-href=>"/cgi-bin/$cgi_name?transaction=transfer"},"Go Back to Transfer Page and try again"),
		p, a({-href=>"/cgi-bin/$cgi_name?transaction=summary"},"Go Back to Summary Page"),
		p, a({-href=>"/cgi-bin/$cgi_name?transaction=logout"},"Logout"),
		hr;

	# check for overdraw attempt
	# Vulnerability - logic fla seen in credit union banking software back in 1998; allowed user to collect balanace statements for other accounts
	# Solution - determine user's authority BEFORE giving balance statement
	}elsif ($bal_list{param('from')} < param('amount'))	{
 		# give balance statement

		print h2('Balance Exceeded'),
 		p,
 		"You attempted to transfer \$", param('amount'), " from account ", param('from'),
 		p,
 		"However, the balance for that account is only \$", $bal_list{param('from')},
 		p,
 		hr;
 		print a({-href=>"/cgi-bin/$cgi_name?transaction=transfer"},"Go Back to Transfer Page and try again"),
		p, a({-href=>"/cgi-bin/$cgi_name?transaction=summary"},"Go Back to Summary Page"),
		p, a({-href=>"/cgi-bin/$cgi_name?transaction=logout"},"Logout"),
		hr;

	# not over drawn so check for authorization on each
	} elsif (param('amount') !~ m/^\d+(\.\d{0,2})?$/) {
		# amount is not valid number

   		print h2('Transfer Unsuccessful'),
 		p,
 		"Transfer amount is not a valid monetary amount.",
 		p,
 		"Be sure amount is of the form 123.23 (Digits only, one decimal point (max), no currency symbols, no commas,etc.",
 		hr;
 		print a({-href=>"/cgi-bin/$cgi_name?transaction=transfer"},"Go Back to the Transfer Page for another transation"),
		p, a({-href=>"/cgi-bin/$cgi_name?transaction=summary"},"Go to the Account Summary Page"),
		p, a({-href=>"/cgi-bin/$cgi_name?transaction=logout"},"Logout"),
		hr;	
	
 	} elsif (((param('to') eq $acct1) || (param('to') eq $acct2)) && ((param('from') eq $acct1) || (param('from') eq $acct2)))  {
 		# Authorized

   print h2('Transfer Successful'),
 		p,
 		"Transfer of \$", param('amount'), " from account ", param('from'), " to account ", param('to'), " was successfull.",
 		p,
 		"NOTE: You will not see any change in the balance for 48 hours because this is not a very robust application :)",
 		hr;
 		print a({-href=>"/cgi-bin/$cgi_name?transaction=transfer"},"Go Back to the Transfer Page for another transation"),
		p, a({-href=>"/cgi-bin/$cgi_name?transaction=summary"},"Go to the Account Summary Page"),
		p, a({-href=>"/cgi-bin/$cgi_name?transaction=logout"},"Logout"),
		hr;
 	}else {
 		#Unauthorized
		print "Content-type: text/html \n\n";
   		print h1('Busted!');
		print img {src=>'/cop_watchit_lg_wht.gif',align=>'LEFT'},
 		p,
 		"You're pathetic attempt to hack has been detected...the police are already approaching your location as you read this",
 		p,
 		hr;
 		print a({-href=>"/cgi-bin/$cgi_name?transaction=transfer"},"If at first you don\'t succeed, try, try again "),
		p, a({-href=>"/cgi-bin/$cgi_name?transaction=summary"},"Go to the Account Summary Page"),
		p, a({-href=>"/cgi-bin/$cgi_name?transaction=logout"},"Escape before the police arrive - Logout"),
		hr;
 	}
	print @footer;
	} elsif (param('transaction') =~ m/[\:\|\||\,|\`|\']/) { #' fake comment to match single quote - otherwise color in Code Genie gets messed up
		# transaction variable contains special characters - produce bogus error message
		# Vulnerability - SQL injection emulated
		print "Content-type: text/html \n\n";
 		print start_html('ODBC Error');
		print h2('Error Occurred While Processing Request'),
		p,
		"Error Diagnostic Information",
		p,
		"ODBC Error Code = 37000 (Syntax error or access violation)",
		p, 
		"[Microsoft][ODBC SQL Server Driver][SQL Server]Line 1: Incorrect syntax near 'transaction'.",
		p,
		"Data Source = \"secretDB\"",
		p,
		"SQL = \"SELECT \* FROM request WHERE sessionID = ", param('sid'), " AND transaction = \'", param('transaction'), "\'\"",
		p, 
		"The error occurred while processing an element with a general identifier of (CFQUERY), occupying document position (6:1) to in",
		p,
		"the template file D\:\\Inetpub\\databases\\bankusers\\user_access.cfm",
	
	} else {
		print "Content-type: text/html \n\n";
 		print start_html('Buggy Bank - Error');
		print @header;
		print h1('You just requested an unknown transaction'),
		p,
		"transaction:", param('transaction'), " unknown",
		p,
		hr;
		print a({-href=>"/cgi-bin/$cgi_name?transaction=transfer"},"Funds Transfers"),
		p, a({-href=>"/cgi-bin/$cgi_name?transaction=summary"},"Account Summary Page"),
		p, a({-href=>"/cgi-bin/$cgi_name?transaction=logout"},"Logout"),
		hr;
		print @footer;
	}

	print end_html;


my $error = cgi_error;
    if ($error) {
	    #print "Content-type: text/html \n\n";
 print header(-status=>$error),
	      start_html('Problems'),
              h2('Request not processed'),
	      strong($error);
        exit 0;
} 
